#ifdef rtl
function QMenu.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QMenu.GetPropList as zstring ptr '''published properties
    dim as string s="Caption"+LF+"Checked"+LF+"RadioItem"+LF+"Enabled"+LF+"Visible"+LF+"Parent"+lf+"CommandID",u=*Base.GetPropList
    dim as zstring ptr zs=callocate(len(s+u)+1)
    *zs=u+lf+s+chr(0)
    return zs
end function

function QMenu.GetPropInfo(n as string) as PELPropInfo
    if n="" then return 0
    dim as PELPropInfo PropInfo=0
    if PropInfo=0 then PropInfo=new QELPropInfo
    select case lcase(n)
    case "checked","radioitem","enabled","visible"
         propinfo->name=callocate(len(n)+1)
         *propinfo->name=n+chr(0)
         propinfo->typekind=tkBool
         return propinfo
    case "caption"
         propinfo->name=callocate(len(n)+1)
         *propinfo->name=n+chr(0)
         propinfo->typekind=tkString
         return propinfo
    case "commandid"
         propinfo->name=callocate(len(n)+1)
         *propinfo->name=n+chr(0)
         propinfo->typekind=tkInteger
         return propinfo
    case "parent"
         propinfo->name=callocate(len(n)+1)
         *propinfo->name=n+chr(0)
         dim as string s=str(cint(fparent))
         propinfo->value=callocate(len(s)+1)
         *propinfo->value=s
         propinfo->typekind=tkType
         return propinfo
    case else
         return Base.GetPropInfo(n)
    end select
end function

function QMenu.SetPropValue(p as string,v as zstring ptr) as boolean
    if p="" then return 0
    select case lcase(p)
    case "parent"
         dim as integer i=val(*v)
         parent=*cast(pmenu,i)
         return parent.handle>0
    case "checked"
         dim as string s=str(fchecked)
         dim as integer vl=valint(*v)
         checked=vl
         return fchecked
    case "radioitem"
         dim as string s=str(fradioitem)
         dim as integer vl=valint(*v)
         radioitem=vl
         return fradioitem
    case "enabled"
         dim as string s=str(fenabled)
         dim as integer vl=valint(*v)
         enabled=vl
         return fenabled
    case "visible"
         dim as string s=str(fvisible)
         dim as integer vl=valint(*v)
         visible=vl
         return fvisible
    case "caption"
         dim as string s=fcaption
         caption=*v
         return s<>""
    case "commandid"
         dim as string s=str(fcommand)
         dim as integer vl=valint(*v)
         commandid=vl
         return fcommand>0
    case else
       return Base.SetPropValue(p,v)
    end select
end function

function QMenu.GetPropValue(p as string) as zstring ptr
    if p="" then return 0
    select case lcase(p)
    case "parent"
       dim as integer i=cint(fparent)
       dim as string s=str(i)
       dim as zstring ptr zs=callocate(len(s)+1)
       *zs=s+chr(0)
       return zs
    case "commandid"
       dim as integer i=commandid
       dim as string s=str(i)
       dim as zstring ptr zs=callocate(len(s)+1)
       *zs=s+chr(0)
       return zs
    case "checked"
       dim as integer i=checked
       dim as string s=str(i)
       dim as zstring ptr zs=callocate(len(s)+1)
       *zs=s+chr(0)
       return zs
    case "radioitem"
       dim as boolean i=radioitem
       dim as string s=str(i)
       dim as zstring ptr zs=callocate(len(s)+1)
       *zs=s+chr(0)
       return zs
    case "enabled"
       dim as boolean i=enabled
       dim as string s=str(i)
       dim as zstring ptr zs=callocate(len(s)+1)
       *zs=s+chr(0)
       return zs
    case "visible"
       dim as boolean i=visible
       dim as string s=str(i)
       dim as zstring ptr zs=callocate(len(s)+1)
       *zs=s+chr(0)
       return zs
    case "caption"
       dim as string s=caption
       dim as zstring ptr zs=callocate(len(s)+1)
       *zs=s+chr(0)
       return zs
    case else
       return Base.GetPropValue(p)
    end select
end function

function QMenu.InheritsFrom(n as string) as boolean
    if (lcase(n)=lcase(classname))  or (lcase(n)="qmenu") then
       return true
    else
       return Base.InheritsFrom(n)
    end if
end function

#endif