#ifdef rtl

#ifndef lf
  #define lf chr(10)
#endif



/'QObject'/
function QObject.MethodExists(m as string) as any ptr
    return 0
end function

function QObject.GetPropList as zstring ptr
    dim as string s="ClassName"+chr(10)+"ClassAncestor"+chr(10)+"Tag"+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QObject.GetPropInfo(n as string) as PELPropInfo
    select case lcase(n)
    case "classname"
         PropInfo=new QELPropInfo
         PropInfo->typekind=tkString
         PropInfo->typename=callocate(len(n)+1)
         *PropInfo->typename=n+chr(0)
         PropInfo->value=callocate(len(classname)+1)
         *PropInfo->value=classname+chr(0)
         return PropInfo
    case "classancestor"
         PropInfo=new QELPropInfo
         PropInfo->typekind=tkString
         PropInfo->typename=callocate(len(n)+1)
         *PropInfo->typename=n+chr(0)
         PropInfo->value=callocate(len(classancestor)+1)
         *PropInfo->value=classancestor+chr(0)
         return PropInfo
    case "tag"
        PropInfo=new QELPropInfo
        PropInfo->typekind=tkInteger
        PropInfo->typename=callocate(len(n)+1)
        *PropInfo->typename=n+chr(0)
        PropInfo->value=callocate(len(str(tag))+1)
        *PropInfo->value=str(tag)+chr(0)
        return PropInfo
    case else
        return 0
    end select
end function

function QObject.GetPropValue(n as string) as zstring ptr
    if n="" then return 0
    select case lcase(n)
    case "classname"
         dim as zstring ptr s=callocate(len(classname)+1)
         *s=classname+chr(0)
         return s
    case "classancestor"
         dim as zstring ptr s=callocate(len(classancestor)+1)
         *s=classancestor+chr(0)
         return s
    case "tag"
          dim as zstring ptr s=callocate(len(str(tag))+1)
         *s=str(tag)+chr(0)
         return s
    end select
    return 0
end function

function QObject.SetPropValue(n as string,v as zstring ptr) as boolean
    if n="" then return 0
    select case lcase(n)
    case "classname"
         classname=*v
         return classname<>""
    case "classancestor"
         classancestor=*v
         return classancestor<>""
    case "tag"
         tag=val(*v)
         return tag>0
    end select
    return 0
end function

function QObject.InheritsFrom(n as string) as boolean
    if (lcase(n)=lcase(classname))  or (lcase(n)="object") then
       return true
    else
       return false
    end if
end function

function QWinFrame.MethodExists(m as string) as any ptr
    return Base.MethodExists(m)
end function

function QWinFrame.GetPropList as zstring ptr
    return Base.GetPropList
end function

function QWinFrame.GetPropInfo(n as string) as PELPropInfo
    return Base.GetPropInfo(n)
end function

function QWinFrame.GetPropValue(n as string) as zstring ptr
    return Base.GetPropValue(n)
end function

function QWinFrame.SetPropValue(n as string,v as zstring ptr) as boolean
    return Base.SetPropValue(n,v)
end function

function QWinFrame.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function/''/

/'QFrame'/
function QFrame.MethodExists(m as string) as any ptr
    select case lcase(m)
    case "refresh"
         this.refresh
         return @this
    end select
    return 0
end function

function QFrame.GetPropList as zstring ptr
    dim as string v=*Base.GetPropList+lf+"Font"+lf+"Text"+lf+"Hint"+lf+"ControlStyle"+lf+"Cursor"+lf+"Color"+lf+"Align"+lf+"Parent"+lf+"ParentWnd"+lf+_
         "Style"+lf+"Exstyle"+lf+"Id"+lf+"Left"+lf+"Top"+lf+"Width"+lf+"Height"+lf+"Handle"+lf+"Enabled"+lf+"Visible"+lf+"ShowHint"+lf+_
         "Clipped"+lf+"TabStop"+lf+"Grouped"+lf+"Control"+lf+"ControlCount"+lf+"ClientWidth"+lf+"ClientHeight"+lf+_
         "ClientRect"+lf+"Windowrect"+lf+"onCreate"+lf+"onDestroy"+lf+"onclick"+lf+"onDblClick"+lf+"onPaint"+lf+"onMouseDown"+lf+_
         "onMouseUp"+lf+"onMouseMove"+lf+"onMouseWheel"+lf+"onKeyDown"+lf+"onKeyPress"+lf+"onCommand"+lf+"onMenu"+lf+"onAccel"
    dim as zstring ptr s=callocate(len(v)+1)
         *s=v+chr(0)
         return s
end function

function QFrame.GetPropInfo(n as string) as PELPropInfo
    if n="" then return 0
         dim as string index=""
         if instr("(",n)>0 then
            n=mid(n,1,instr("(",n)-1)
            index=mid(n,instr("(",n)+1,instr(")",n)-instr("(",n)-1)
         end if
         
         select case lcase(n)
              case "align"
                 PropInfo=new QELPropInfo
                 dim as string s="alNone,alLeft,alRight,alTop,alBottom,alClient"
                 PropInfo->typekind=tkEnum
                 PropInfo->typename=callocate(len("QAlign")+1)
                 *PropInfo->typename="QAlign"+chr(0)
                 PropInfo->name=callocate(len(s)+1)
                 *PropInfo->name=s+chr(0)
                 PropInfo->value=callocate(len(str(falign))+1)
                 *PropInfo->value=str(falign)+chr(0)
                 return PropInfo
              case "controlstyle"
                 PropInfo=new QELPropInfo
                 PropInfo->typename=callocate(len("QControlStyle")+1)
                 *PropInfo->typename="QControlStyle"
                 PropInfo->name=callocate(len("csDefault,csAcceptChilds,csTransparent")+1)
                 *PropInfo->name="csDefault,csAcceptChilds,csTransparent"
                 PropInfo->value=callocate(len(str(fcontrolstyle))+1)
                 *PropInfo->value=str(fcontrolstyle)+chr(0)
                 PropInfo->TypeKind=tkInteger
                 return PropInfo
             case "controlstate"
                 PropInfo=new QELPropInfo
                 PropInfo->typename=callocate(len("QControlState")+1)
                 *PropInfo->typename="QControlState"
                 PropInfo->name=callocate(len("csDefault,csReplicatable,csDesign")+1)
                 *PropInfo->name="csDefault,csReplicatable,csDesign"
                 PropInfo->value=callocate(len(str(fcontrolstate))+1)
                 *PropInfo->value=str(fcontrolstate)+chr(0)
                 PropInfo->TypeKind=tkInteger
                 return PropInfo
             case "cursor"
                 PropInfo=new QELPropInfo
                 PropInfo->typename=callocate(len("QCursor")+1)
                 *PropInfo->typename="QCursor"
                 PropInfo->name=callocate(len("crNone,crArrow,crSize,crSizeNE,crSizeSE,crSizeNV,crSizeSV,crWait,crHand,crCross")+1)
                 *PropInfo->name="crNone,crArrow,crSize,crSizeNE,crSizeSE,crSizeNV,crSizeSV,crWait,crHand,crCross"
                 PropInfo->value=callocate(len(str(fcursor))+1)
                 *PropInfo->value=str(fcursor)+chr(0)
                 PropInfo->TypeKind=tkInteger
                 return PropInfo
             case "color"
                 PropInfo=new QELPropInfo
                 PropInfo->typename=callocate(len("colorref")+1)
                 *PropInfo->typename="colorref"
                 PropInfo->value=callocate(len(str(fcolor))+1)
                 *PropInfo->value=str(fcolor)+chr(0)
                 PropInfo->name=callocate(len("clWindow,clBtnFace,clWindowText")+1)
                 *PropInfo->name="clWindow,clBtnFace,clWindowText"
                 PropInfo->editor=callocate(len("TELColorEditor")+1)
                 *PropInfo->Editor="TELColorEditor"+chr(0)
                 PropInfo->TypeKind=tkInteger
                 return PropInfo
             case "enabled","visible","showhint","clipped","tabstop","grouped"
                  PropInfo=new QELPropInfo
                  PropInfo->typekind=tkBool
                  PropInfo->typename=callocate(len("boolean")+1)
                  *PropInfo->typename="boolean"+chr(0)
                  PropInfo->name=callocate(len("false,true")+1)
                  *PropInfo->name="False,True"+chr(0)
                  if lcase(n)="enabled" then
                     PropInfo->value=callocate(len(str(enabled))+1)
                     *PropInfo->value=str(enabled)+chr(0)
                  elseif lcase(n)="visible" then
                     PropInfo->value=callocate(len(str(visible))+1)
                     *PropInfo->value=str(visible)+chr(0)
                  elseif lcase(n)="showhint" then
                     PropInfo->value=callocate(len(str(showhint))+1)
                     *PropInfo->value=str(showhint)+chr(0)
                  elseif lcase(n)="clipped" then
                     PropInfo->value=callocate(len(str(clipped))+1)
                     *PropInfo->value=str(clipped)+chr(0)
                  elseif lcase(n)="tabstop" then
                     PropInfo->value=callocate(len(str(tabstop))+1)
                     *PropInfo->value=str(tabstop)+chr(0)
                  elseif lcase(n)="tabstop" then
                    PropInfo->value=callocate(len(str(tabstop))+1)
                    *PropInfo->value=str(tabstop)+chr(0)
                  elseif lcase(n)="grouped" then
                     PropInfo->value=callocate(len(str(grouped))+1)
                     *PropInfo->value=str(grouped)+chr(0)
                  end if
                  return PropInfo
              case "font","parent"
                 PropInfo=new QELPropInfo
                 PropInfo->typekind=tkType
                 if lcase(n)="font" then
                    PropInfo->typename=callocate(len("QFont")+1)
                    *PropInfo->typename="QFont"+chr(0)
                    PropInfo->name=callocate(len("Font")+1)
                    *PropInfo->name="Font"+chr(0)
                    PropInfo->value=callocate(len(str(font))+1)
                    *PropInfo->value=str(font)+chr(0)
                    PropInfo->editor=callocate(len("telfonteditor")+1)
                    *PropInfo->editor="TELFontEditor"+chr(0)
                    return PropInfo
                 elseif lcase(n)="parent" then
                    PropInfo->typename=callocate(len("QFrame")+1)
                    *PropInfo->typename="QFrame"+chr(0)
                    dim as string s=""
                    if fparent then
                       s=*fparent
                    else
                       s=""
                    end if
                    PropInfo->name=callocate(len(s)+1)
                    *PropInfo->name=s+chr(0)
                    PropInfo->value=callocate(len(str(fparent))+1)
                    *PropInfo->value=str(fparent)+chr(0)
                    return PropInfo
                 end if
              case "hint","text"
                 PropInfo=new QELPropInfo
                 PropInfo->typekind=tkString
                 PropInfo->typename=callocate(len(n)+1)
                 *PropInfo->typename=n+chr(0)
                 if lcase(n)="text" then
                    PropInfo->name=callocate(len("text")+1)
                    *PropInfo->name="text"+chr(0)
                    PropInfo->value=callocate(len(text)+1)
                   *PropInfo->value=text+chr(0)
                 elseif lcase(n)="hint" then
                    PropInfo->name=callocate(len("hint")+1)
                    *PropInfo->name="hint"+chr(0)
                    PropInfo->value=callocate(len(hint)+1)
                    *PropInfo->value=hint+chr(0)
                 end if
                 return PropInfo
              case "parentwnd","style","exstyle","id","left","top","width","height","handle"
                 PropInfo=new QELPropInfo
                 PropInfo->typekind=tkInteger
                 PropInfo->typename=callocate(len(n)+1)
                 *PropInfo->typename=n+chr(0)
                 if lcase(n)="parentwnd" then
                    PropInfo->name=callocate(len("parentwnd")+1)
                    *PropInfo->name="parentwnd"+chr(0)
                    PropInfo->value=callocate(len(str(parentwnd))+1)
                    *PropInfo->value=str(parentwnd)+chr(0)
                 elseif lcase(n)="id" then
                    PropInfo->name=callocate(len("id")+1)
                    *PropInfo->name="id"+chr(0)
                    PropInfo->value=callocate(len(str(fid))+1)
                    *PropInfo->value=str(id)+chr(0)
                 elseif lcase(n)="style" then
                    PropInfo->name=callocate(len("style")+1)
                    *PropInfo->name="style"+chr(0)
                    PropInfo->value=callocate(len(str(fstyle))+1)
                    *PropInfo->value=str(style)+chr(0)
                 elseif lcase(n)="exstyle" then
                    PropInfo->name=callocate(len("exstyle")+1)
                    *PropInfo->name="exstyle"+chr(0)
                    PropInfo->value=callocate(len(str(fexstyle))+1)
                    *PropInfo->value=str(exstyle)+chr(0)
                 elseif lcase(n)="left" then
                    PropInfo->name=callocate(len("left")+1)
                    *PropInfo->name="left"+chr(0)
                    PropInfo->value=callocate(len(str(left))+1)
                    *PropInfo->value=str(left)+chr(0)
                 elseif lcase(n)="top" then
                    PropInfo->name=callocate(len("top")+1)
                    *PropInfo->name="top"+chr(0)
                    PropInfo->value=callocate(len(str(ftop))+1)
                    *PropInfo->value=str(top)+chr(0)
                 elseif lcase(n)="width" then
                    PropInfo->name=callocate(len("width")+1)
                    *PropInfo->name="width"+chr(0)
                    PropInfo->value=callocate(len(str(fwidth))+1)
                    *PropInfo->value=str(width)+chr(0)
                 elseif lcase(n)="height" then
                    PropInfo->name=callocate(len("height")+1)
                    *PropInfo->name="height"+chr(0)
                    PropInfo->value=callocate(len(str(fheight))+1)
                    *PropInfo->value=str(height)+chr(0)
                 elseif lcase(n)="handle" then
                    PropInfo->name=callocate(len("handle")+1)
                    *PropInfo->name="handle"+chr(0)
                    PropInfo->value=callocate(len(str(fhandle))+1)
                    *PropInfo->value=str(fhandle)+chr(0)
                 end if
                 return PropInfo
             case "control"
                  PropInfo=new QELPropInfo
                  dim as string index="",s=""
                  if instr(n,"(")>0 then
                     index=mid(n,instr(n,"(")+1,instr(n,")")-instr(n,"(")-1)
                     n=mid(n,1,instr(n,"(")-1)
                  end if
                  s=this
                  PropInfo->typename=callocate(Len(s)+1)
                  *PropInfo->typename=s+chr(0)
                  return PropInfo
             case "controlcount","clientwidth","clientheight"
                  PropInfo=new QELPropInfo
                  PropInfo->typekind=tkInteger
                  PropInfo->typename=callocate(len("integer")+1)
                  *PropInfo->typename="integer"+chr(0)
                  PropInfo->name=callocate(len(n)+1)
                  *PropInfo->typename=n+chr(0)
                  if lcase(n)="controlcount" then
                     PropInfo->value=callocate(len(str(fcontrolcount))+1)
                     *PropInfo->value=str(fcontrolcount)+chr(0)
                  elseif lcase(n)="clientwidth" then
                     PropInfo->value=callocate(len(str(fclientwidth))+1)
                     *PropInfo->value=str(fclientwidth)+chr(0)
                  elseif lcase(n)="clientheight" then
                     PropInfo->value=callocate(len(str(fclientheight))+1)
                     *PropInfo->value=str(fclientheight)+chr(0)
                  end if
                  return PropInfo
             case "clientrect","windowrect"
                  PropInfo=new QELPropInfo
                  PropInfo->typekind=tkType
                  PropInfo->typename=callocate(len("rect")+1)
                  *PropInfo->typename="rect"+chr(0)
                  PropInfo->name=callocate(len(n)+1)
                  *PropInfo->name=n+chr(0)
                  if lcase(n)="clientrect" then
                     dim as integer v=*(cast(integer ptr,@fclientrect))
                     PropInfo->value=callocate(len(str(v))+1)
                     *PropInfo->value=str(v)+chr(0)
                  elseif lcase(n)="windowrect" then
                     dim as integer v=*(cast(integer ptr,@fwindowrect))
                     PropInfo->value=callocate(len(str(v))+1)
                     *PropInfo->value=str(v)+chr(0)
                  end if
                  return PropInfo
             case "oncreate","ondestroy","onclick","ondblclick","onpaint","onmousedown","onmouseup","onmousemove","onmousewheel","onkeydown","onkeypress","oncommand","onmenu","onaccel"
                  PropInfo=new QELPropInfo
                  PropInfo->typekind=tkMethod
                  dim as string s=strToEvKind(n)
                  PropInfo->typeName=callocate(len(s)+1)
                  *PropInfo->typename=s+chr(0)
                  PropInfo->Name=callocate(len(n)+1)
                  *PropInfo->name=n+chr(0)
                  s=*GetPropValue(n)
                  PropInfo->value=callocate(len(s)+1)
                  *PropInfo->value=s+chr(0)
                  return PropInfo
             case "dummy"
                   PropInfo=new QELPropInfo
                   PropInfo->typekind=tkUnknown
                   return PropInfo          
             case else
                  return Base.GetPropInfo(n)
                  
         end select
end function

function QFrame.GetPropValue(n as string) as zstring ptr
    dim as string index=""
         if instr("(",n)>0 then
            n=mid(n,1,instr("(",n)-1)
            index=mid(n,instr("(",n)+1,instr(")",n)-instr("(",n)-1)
         else
            index=""
         end if
    select case lcase(n)
    case "text"
         dim as zstring ptr s=callocate(len(ftext)+1)
         *s=text
         return s
    case "hint"
         dim as zstring ptr s=callocate(len(fhint)+1)
         *s=fhint
         return s
    case "controlstyle"
         dim as integer i=cint(fcontrolstyle)
         dim as zstring ptr s=callocate(4)
         *s=str(i)
         return s
    case "controlstate"
         dim as integer i=cint(fcontrolstate)
         dim as zstring ptr s=callocate(4)
         *s=str(i)
         return s
    case "cursor"
         dim as integer i=cint(fcursor)
         dim as zstring ptr s=callocate(4)
         *s=str(i)
         return s
    case "color"
         dim as integer i=cint(fcolor)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)
         return s
    case "align"
         dim as integer i=cint(Align)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)
         return s
    case "parent"
         dim as integer i=cint(Parent)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)
         return s
    case "parentwnd"
         dim as integer i=cint(fParentWnd)
         dim as zstring ptr s=callocate(len(str(fparentwnd))+1)
         *s=str(i)
         return s
    case "style"
         dim as integer i=Style
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)
         return s
    case "exstyle"
         dim as integer i=Exstyle
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)
         return s
    case "id"
         dim as integer i=cint(fid)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "left"
         dim as integer i=left
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "top"
         dim as integer i=top
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "width"
         dim as integer i=width
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "height"
         dim as integer i=height
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "handle"
         dim as hwnd i=handle
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s     
    case "enabled"
         dim as integer i=enabled
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "visible"
         dim as integer i=visible
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "clipped"
         dim as integer i=clipped
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "tabstop"
         dim as integer i=tabstop
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "grouped"
         dim as integer i=cint(grouped)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "showhint"
         dim as integer i=cint(showhint)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "control"
         dim as integer i=valint(index)
         if i>-1 and i<fcontrolcount then
            dim as pframe f=fcontrols[i]
            dim as integer ctrl=cint(f)
            dim as zstring ptr result=callocate(len(str(ctrl))+1)
            *result=str(ctrl)+chr(0)
            return result
         else
            return 0
         end if
    case "controlcount"
         dim as integer i=fcontrolcount
         dim as zstring ptr result=callocate(len(str(i))+1)
         *result=str(i)+chr(0)
         return result
    case "clientwidth"
         dim as integer i=clientwidth
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "clientheight"
         dim as integer i=clientheight
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "clientrect"
         dim as prect i=@fclientrect
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "windowrect"
         dim as prect i=@fwindowrect
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "font"
         dim as integer i=cint(ffont)
         dim as string s=str(i)
         dim as zstring ptr zs=callocate(len(s)+1)
         *zs=s+chr(0)
         return zs
    case "oncreate"
         dim as integer i=cint(oncreate)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "ondestroy"
         dim as integer i=cint(ondestroy)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "onclick"
         dim as integer i=cint(onclick)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "ondblclick"
         dim as integer i=cint(ondblclick)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "onpaint"
         dim as integer i=cint(onpaint)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "onmousedown"
         dim as integer i=cint(ondestroy)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "onmouseup"
         dim as integer i=cint(onmouseup)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "onmousemove"
         dim as integer i=cint(onmousemove)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "onmousewheel"
         dim as integer i=cint(onmousewheel)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "onkeydown"
         dim as integer i=cint(onkeydown)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "onkeypress"
         dim as integer i=cint(onkeypress)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "oncommand"
         dim as integer i=cint(oncommand)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "onmenu"
         dim as integer i=cint(onmenu)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case "onaccel"
         dim as integer i=cint(onaccel)
         dim as zstring ptr s=callocate(len(str(i))+1)
         *s=str(i)+chr(0)
         return s
    case else
         return Base.GetPropValue(n)
    end select
end function

function QFrame.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as string index=""
         if instr("(",n)>0 then
            n=mid(n,1,instr("(",n)-1)
            index=mid(n,instr("(",n)+1,instr(")",n)-instr("(",n)-1)
         else
            index=""
         end if
    dim as zstring ptr zv=callocate(len(*v)+1)
    *zv=*v
    select case lcase(n)
    case "text"
         text=*zv
         return ftext<>""
    case "hint"
         hint=*v
         return hint<>""
    case "controlstyle"
         dim as integer i=valint(*v)
         controlstyle=i
         return controlstyle=qcontrolstyle.csdefault
    case "controlstate"
         dim as integer i=valint(*v)
         controlstate=i
         return controlstate=qcontrolstate.csnormal
    case "cursor"
         dim as integer i=valint(*v)
         cursor=i
         return cursor=crdefault/''/
    case "align"
         dim as integer i=valint(*v)
         align=i
         return align=alnone
    case "parent"
         dim as integer i=valint(*v)
         parent=cast(PFrame,i)
         return parent=0
    case "parentwnd"
         dim as integer i=valint(*v)
         parentwnd=cast(hwnd,i)
         return parentwnd=0
    case "style"
         dim as integer i=valint(*v)
         style=i
         return style=0
    case "exstyle"
         dim as integer i=valint(*v)
         exstyle=i
         return exstyle=0
    case "id"
         dim as integer i=valint(*v)
         id=i
         return id=0
    case "color"
         dim as integer i=valint(*v)
         color=i
         return color=0
    case "left"
         dim as integer i=valint(*v)
         left=i
         return left=0
    case "top"
         dim as integer i=valint(*v)
         top=i
         return top=0
    case "width"
         dim as integer i=valint(*v)
         width=i
         return width=0
    case "height"
         dim as integer i=valint(*v)
         height=i
         return height=0
    case "enabled"
         dim as integer i=valint(*v)
         enabled=i
         return enabled=0
    case "visible"
         dim as integer i=valint(*v)
         visible=i
         return visible=0
    case "clipped"
         dim as integer i=valint(*v)
         clipped=i
         return clipped=0
    case "tabstop"
         dim as integer i=valint(*v)
         tabstop=i
         return tabstop=0
    case "grouped"
         dim as integer i=valint(*v)
         grouped=i
         return grouped=0
    case "control"
         dim as integer i=valint(index),c=valint(*v)
         if i>-1 and i<fcontrolcount then
            fcontrols[i]=cast(pFrame,c)
            return (fcontrols[i]>0)
         end if
         return 0
    case "controlcount"
         dim as integer i=0,x=*v
         for i=0 to x-1
             add(new QFrame)
         next
         return fcontrolcount
    case "clientwidth"
         dim as integer i=valint(*v)
         clientwidth=i
         return clientwidth=0
    case "clientheight"
         dim as integer i=valint(*v)
         clientheight=i
         return clientheight=0
    case "clientrect"
         dim as integer i=valint(*v)
         clientrect=*cast(prect,i)
         return (clientrect.left=0 and clientrect.top=0 and clientrect.right=0 and clientrect.bottom=0)
    case "windowrect"
         dim as integer i=valint(*v)
         windowrect=*cast(prect,i)
         return (windowrect.left=0 and windowrect.top=0 and windowrect.right=0 and windowrect.bottom=0)
    case "font"
         dim as integer i=valint(*v)
         font=*cast(pfont,i)
         return (ffont>0)
    case "oncreate"
         dim as integer i=valint(*v)
         oncreate=cast(QEvent,i)
         return oncreate<>0
    case "ondestroy"
         dim as integer i=valint(*v)
         oncreate=cast(QEvent,i)
         return ondestroy<>0
    case "onclick"
         dim as integer i=valint(*v)
         onclick=cast(QEvent,i)
         return onclick<>0
    case "ondblclick"
         dim as integer i=valint(*v)
         ondblclick=cast(QEvent,i)
         return ondblclick<>0
    case "onpaint"
         dim as integer i=valint(*v)
         onpaint=cast(QEvent,i)
         return onpaint<>0
    case "onmousedown"
         dim as integer i=valint(*v)
         onmousedown=cast(QMouseEvent,i)
         return onmousedown<>0
    case "onmouseup"
         dim as integer i=valint(*v)
         onmouseup=cast(QMouseEvent,i)
         return onmouseup<>0
    case "onmousemove"
         dim as integer i=valint(*v)
         onmousemove=cast(QMouseMoveEvent,i)
         return onmousemove<>0
    case "onmousewheel"
         dim as integer i=valint(*v)
         onmousewheel=cast(QMouseWheelEvent,i)
         return onmousewheel<>0
    case "onkeydown"
         dim as integer i=valint(*v)
         onkeydown=cast(QKeyEvent,i)
         return onkeydown<>0
    case "onkeyup"
         dim as integer i=valint(*v)
         onkeyup=cast(QKeyEvent,i)
         return onkeyup<>0
    case "onkeypress"
         dim as integer i=valint(*v)
         onkeypress=cast(QCharEvent,i)
         return onkeypress<>0
    case "oncommand"
         dim as integer i=valint(*v)
         oncommand=cast(QCommandEvent,i)
         return oncommand<>0
    case "onmenu"
         dim as integer i=valint(*v)
         onmenu=cast(QMenuEvent,i)
         return onmenu<>0
    case "onaccel"
         dim as integer i=valint(*v)
         onaccel=cast(QMenuEvent,i)
         return onaccel<>0
    case else
         return Base.SetPropValue(n,v)
    end select
    return 0
end function

function QFrame.InheritsFrom(n as string) as boolean
    if (lcase(n)=lcase(classname))  or (lcase(n)="qframe") then
       return true
    else
       return Base.InheritsFrom(n)
    end if
end function

/'QGeneric'/
function QGeneric.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QGeneric.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(10)+"Host"+chr(0)
    dim as zstring ptr zs=callocate(len(s)+1)
    *zs=s+chr(0)
    return zs
end function

function QGeneric.GetPropInfo(n as string) as PELPropInfo
    if n="" then return 0
    PropInfo=new QELPropInfo
    select case lcase(n)
    case "host"
         PropInfo->typekind=tkString
         PropInfo->typename=callocate(len("string")+1)
         *PropInfo->typename="string"+chr(0)
         PropInfo->value=callocate(len(fhost)+1)
         *PropInfo->value=fhost+chr(0)
         return PropInfo
    case else
         return Base.GetPropInfo(n)
    end select
end function

function QGeneric.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "host"
         dim as zstring ptr ret=callocate(len(host)+1)
         *ret=fhost+chr(0)
         return ret
    case else
         return Base.GetPropValue(n)
    end select
end function

function QGeneric.SetPropValue(n as string,v as zstring ptr) as boolean
    select case lcase(n)
    case "host"
          host=*v
          return true
    case else
         return Base.SetPropValue(n,v)
    end select
end function

function QGeneric.InheritsFrom(n as string) as boolean
    if (lcase(n)=lcase(classname))  or (lcase(n)="qgeneric") then
       return true
    else
       return Base.InheritsFrom(n)
    end if
end function

/'QForm'/
function QForm.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QForm.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(10)+"BorderIcons"+chr(10)+"FormBorder"+chr(10)+"FormStyle"+chr(10)+"WindowState"+chr(10)+"MainMenu"+chr(10)+"PopupMenu"/''/
    dim as zstring ptr zs=callocate(len(s)+1)
    *zs=s+chr(0)
    return zs
end function

function QForm.GetPropInfo(n as string) as PELPropInfo
    if n="" then return 0
    
    if lcase(n)="formborder" then
         PropInfo=new QELPropInfo
         PropInfo->typekind=tkEnum
         PropInfo->name=callocate(len("bsNone,bsSingle,bsSizeable,bsSizeTool,bsToolWindow")+1)
         *PropInfo->name="bsNone,bsSingle,bsSizeable,bsSizeTool,bsToolWindow"+chr(0)
         PropInfo->typename=callocate(len("qformborder")+1)
         *PropInfo->typename="QFormBorder"+chr(0)
         PropInfo->value=callocate(len(str(fformborder))+1)
         *PropInfo->value=str(fformborder)+chr(0)
         return PropInfo
    elseif lcase(n)="formstyle" then
         PropInfo=new QELPropInfo
         PropInfo->typekind=tkEnum
         PropInfo->name=callocate(len("fsNormal,fsMDIClient,fsMDIChild,fsStayOnTop")+1)
         *PropInfo->name="fsNormal,fsMDIClient,fsMDIChild,fsStayOnTop"+chr(0)
         PropInfo->typename=callocate(len("qformstyle")+1)
         *PropInfo->typename="QFormStyle"+chr(0)
         PropInfo->value=callocate(len(str(fformstyle))+1)
         *PropInfo->value=str(fformstyle)+chr(0)
         return PropInfo
    elseif lcase(n)="bordericons" then
         PropInfo=new QELPropInfo
         PropInfo->typekind=tkSet
         PropInfo->name=callocate(len("biNone,biMaximixe,biMinimize")+1)
         *PropInfo->name="biNone,biMaximixe,biMinimize"+chr(0)
         PropInfo->typename=callocate(len("qbordericons")+1)
         *PropInfo->typename="QBorderIcons"+chr(0)
         PropInfo->value=callocate(len(str(fbordericons))+1)
         *PropInfo->value=str(fbordericons)+chr(0)
         return PropInfo
    elseif lcase(n)="windowstate" then
         PropInfo=new QELPropInfo
         PropInfo->typekind=tkEnum
         PropInfo->name=callocate(len("wsNormal,wsHide,wsMinimized,wsMaximized,wsRestored")+1)
         *PropInfo->name="wsNormal,wsHide,wsMinimized,wsMaximized,wsRestored"+chr(0)
         PropInfo->typename=callocate(len("qwindowstate")+1)
         *PropInfo->typename="QWindowState"+chr(0)
         PropInfo->value=callocate(len(str(fwindowstate))+1)
         *PropInfo->value=str(fwindowstate)+chr(0)
         return PropInfo
    elseif lcase(n)="mainmenu" then
         PropInfo=new QELPropInfo
         PropInfo->typekind=tkType
         PropInfo->name=callocate(len("mainmenu")+1)
         *PropInfo->name="mainmenu"+chr(0)
         PropInfo->typename=callocate(len("qmainmenu")+1)
         *PropInfo->typename="QMainMenu"+chr(0)
         PropInfo->value=callocate(len(str(fmainmenu))+1)
         *PropInfo->value=str(fmainmenu)+chr(0)
         return PropInfo
    elseif lcase(n)="popupmenu" then
         PropInfo=new QELPropInfo
         PropInfo->typekind=tkType
         PropInfo->name=callocate(len("popupmenu")+1)
         *PropInfo->name="popupmenu"+chr(0)
         PropInfo->typename=callocate(len("qpopupmenu")+1)
         *PropInfo->typename="QPopupMenu"+chr(0)
         PropInfo->value=callocate(len(str(fpopupmenu))+1)
         *PropInfo->value=str(fpopupmenu)+chr(0)
         return PropInfo
    elseif lcase(n)="dummy" then
         PropInfo=new QELPropInfo
         PropInfo->typekind=tkUnknown
         return PropInfo     
    else
         return Base.GetPropInfo(n)
    end if
end function

function QForm.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "formborder"
         dim as zstring ptr ret=callocate(len(str(fformborder))+1)
         *ret=str(formborder)+chr(0)
         return ret
    case "formstyle"
         dim as zstring ptr ret=callocate(len(str(fformstyle))+1)
         *ret=str(fformstyle)+chr(0)
         return ret
    case "bordericons"
         dim as zstring ptr ret=callocate(len(str(fbordericons))+1)
         *ret=str(fbordericons)+chr(0)
         return ret     
    case "windowstate"
          dim as zstring ptr ret=callocate(len(str(fwindowstate))+1)
         *ret=str(fwindowstate)+chr(0)
         return ret
    case "mainmenu"
          dim as zstring ptr ret=callocate(len(str(fmainmenu))+1)
         *ret=str(fmainmenu)+chr(0)
         return ret
    case "popupmenu"
          dim as zstring ptr ret=callocate(len(str(fpopupmenu))+1)
         *ret=str(fpopupmenu)+chr(0)
         return ret
    case else
         return Base.GetPropValue(n)
    end select
end function

function QForm.SetPropValue(n as string,v as zstring ptr) as boolean
    select case lcase(n)
    case "formborder"
          FormBorder=val(*v)
          return true
    case "formstyle"
          formstyle=val(*v)
          return true
    case "windowstate"
          windowstate=val(*v)
          return true
    case "mainmenu"
          dim as integer vl=val(*v)
          dim as any ptr i=cast(any ptr,vl)
          mainmenu=(*cast(pmainmenu,i))
          return true
    case "popupmenu"
          dim as integer vl=val(*v)
          dim as any ptr i=cast(any ptr,vl)
          fpopupmenu=(*cast(ppopupmenu,i))
          return true
    case else
         return Base.SetPropValue(n,v)
    end select
end function

function QForm.InheritsFrom(n as string) as boolean
    if (lcase(n)=lcase(classname))  or (lcase(n)="qform") then
       return true
    else
       return Base.InheritsFrom(n)
    end if
end function

'''global'
function GetPropList(o as pobject) as zstring ptr export
    if o then
       if *o="QObject" then return o->GetPropList
    end if
    return 0
end function

function GetPropInfo(o as pobject,n as zstring ptr) as PELPropInfo export
    dim as QStringList l
    l=*GetPropList(o)
    if n then if l.indexof(*n)=-1 then return 0
    if o then
       if *o="QObject" then return o->GetPropInfo(*n)
    end if
    return 0
end function

function GetPropValue(o as pobject,n as zstring ptr) as zstring ptr export
    if o then
       if *o="QObject" then return o->GetPropValue(*n)
    end if
    return 0
end function

function SetPropValue(o as pobject,n as zstring ptr,v as zstring ptr) as boolean export
    if o then
       if *o="QObject" then return o->SetPropValue(*n,v)
    end if
    return 0
end function

function MethodExists(o as pobject,m as zstring ptr) as any ptr
    if o then
       if *o="QObject" then return o->MethodExists(*m)
    end if
    return 0
end function

#endif