/' QFont '/
#ifdef rtl

#ifndef lf
  #define lf chr(10)
#endif

function QFont.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QFont.GetPropValue(n as string) as zstring ptr
    if n="" then return 0
    select case lcase(trim(n))
    case "facename"
         dim as zstring ptr s=callocate(len(ffacename)+1)
         *s=ffacename+chr(0)
         return s
    case "size"
         dim as zstring ptr s=callocate(len(str(fsize))+1)
         *s=str(fsize)+chr(0)
         return s
    case "color"
         dim as zstring ptr s=callocate(len(str(fcolor))+1)
         *s=str(fcolor)+chr(0)
         return s
    case "bold"
         dim as zstring ptr s=callocate(len(str(fbold))+1)
         *s=str(fbold)+chr(0)
         return s
    case"italic"
         dim as zstring ptr s=callocate(len(str(fitalic))+1)
         *s=str(fitalic)+chr(0)
         return s
    case "underline"
         dim as zstring ptr s=callocate(len(str(funderline))+1)
         *s=str(funderline)+chr(0)
         return s
    case "strikeout"
         dim as zstring ptr s=callocate(len(str(fstrikeout))+1)
         *s=str(fstrikeout)+chr(0)
         return s
    case "handle"
         dim as zstring ptr s=callocate(len(str(handle))+1)
         *s=str(handle)+chr(0)
         return s
    case else
         return Base.GetPropValue(n)/''/
    end select
end function

function QFont.SetPropValue(n as string,v as zstring ptr) as boolean
    if n="" then return 0
    select case lcase(trim(n))
    case "facename"
          this.facename=*v
          return facename<>""
    case "size"
          this.size=cast(integer,valint(str(*v)))
          return size>0
    case "color"
          this.color=cast(integer,valint(str(*v)))
          return color>0
    case "bold"
          this.bold=cast(integer,valint(str(*v)))
          return bold
    case"italic"
          this.italic=cast(integer,valint(str(*v)))
          return italic
    case "underline"
          this.underline=cast(integer,valint(str(v)))
          return underline
    case "strikeout"
          this.strikeout=cast(integer,valint(str(v)))
          return strikeout
    case "handle"
          dim as integer ptr i=callocate(sizeof(integer))
          *i=valint(*v)
          this.handle=cast(hfont,*i)
          return handle>0
    case else
         return Base.SetPropValue(n,v)/''/
    end select
end function

function QFont.GetPropList as zstring ptr '''published properties
    dim as string s="FaceName"+lf+"Size"+lf+"Color"+lf+"Bold"+lf+"Italic"+lf+"Underline"+lf+"Strikeout"+lf+"Handle"
    dim as zstring ptr zs=callocate(len(s)+1)
    *zs=s+chr(0)
    return zs
end function

function QFont.GetPropInfo(n as string) as PELPropInfo
    if n="" then return 0/''/
    select case lcase(trim(n))
    case "facename"
         dim as PELPropInfo Pif=new QELPropInfo
         Pif->name=callocate(len("facename")+1)
         *pif->name="facename"
         pif->value=callocate(len(facename)+1)
         *pif->value=facename
         pif->typekind=tkString
         return pif
    case "size"
         dim as PELPropInfo Pif=new QELPropInfo
         pif->name=callocate(len("size")+1)
         *pif->name="size"+chr(0)
         pif->value=callocate(len(str(size))+1)
         *pif->value=str(size)+chr(0)
         pif->typekind=tkInteger
         return pif
    case "bold","italic","underline","strikeout"
         dim as PELPropInfo Pif=new QELPropInfo
         pif->name=callocate(len(n)+1)
         *pif->name=n+chr(0)
         pif->value=callocate(len(*GetPropValue(n))+1)
         *pif->value=*GetPropValue(n)+chr(0)
         pif->typekind=tkBool
         return pif
    case "handle"
         dim as PELPropInfo Pif=new QELPropInfo
         pif->name=callocate(len("handle")+1)
         *pif->name="handle"+chr(0)
         pif->value=callocate(len(str(handle))+1)
         *pif->value=str(handle)+chr(0)
         pif->typename=callocate(len("hfont")+1)
         *pif->typename="hfont"+chr(0)
         pif->typekind=tkInteger
         return pif
    case "color"
         dim as PELPropInfo Pif=new QELPropInfo
         pif->name=callocate(len("clwindow,clbtnface,clwindowtext")+1)
         *pif->name="clWindow,clBtnFace,clWindowText"+chr(0)
         pif->value=callocate(len(str(color))+1)
         *pif->value=str(color)+chr(0)
         pif->typename=callocate(len("colorref")+1)
         *pif->typename="colorref"+chr(0)
         pif->editor=callocate(len("TELColorEditor")+1)
         *pif->editor="TELColorEditor"+chr(0)
         pif->typekind=tkInteger
         return pif
    case else
         return Base.GetPropInfo(n)/''/
    end select
end function

function QFont.InheritsFrom(v as string) as boolean
    return Base.inheritsFrom(v)
end function
#endif