#ifdef rtl

/'QStatic'/
function QStatic.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QStatic.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(10)+"Alignment"+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QStatic.GetPropInfo(n as string) as PELPropInfo
    
    select case lcase(n)
    case "alignment"
         PropInfo=new QELPropInfo
         PropInfo->typekind=tkInteger
         PropInfo->typename=callocate(len("QAlignment")-+1)
         *PropInfo->typename="QAlignment"+chr(0)
         PropInfo->value=callocate(len(str(falignment)+chr(0)))
         *PropInfo->value=str(falignment)
         PropInfo->name=callocate(len("taLeft,taCenter,taRight"+chr(0)))
         *PropInfo->name="taLeft,taCenter,taRight"+chr(0)
         return PropInfo
    case else
        return Base.GetPropInfo(n)
    end select
    return PropInfo
end function

function QStatic.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "alignment"
         dim as zstring ptr result=callocate(len(str(falignment)+chr(0)))
         *result=str(falignment)
         return result
    case "onclick"
         dim as zstring ptr result=callocate(len(str(onclick)+chr(0)))
         *result=str(onclick)
         return result
    case else
        return Base.GetPropValue(n)
    end select
    return 0
end function

function QStatic.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as zstring ptr old
    select case lcase(n)
    case "alignment"
         old=callocate(len(str(falignment)+chr(0)))
         *old=str(falignment)
         alignment=val(*v)
         return old<>falignment
    case "onclick"
         old=callocate(len(str(onclick)+chr(0)))
         *old=str(onclick)
         dim as integer i=val(*v)
         onClick=cast(QEvent,i)
         return old<>onclick
    case else
        return Base.SetPropValue(n,v)
    end select
    return false
end function

function QStatic.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function

/'QButton'/
function QButton.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QButton.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QButton.GetPropInfo(n as string) as PELPropInfo
    PropInfo=new QELPropInfo
    PropInfo->typename=callocate(len(n)+1)
    *PropInfo->typename=n+chr(0)
    select case lcase(n)
    case "onclick"
         PropInfo->value=callocate(len(str(onclick))+1)
         *PropInfo->value=str(onclick)+chr(0)
         PropInfo->name=callocate(len("Event"+chr(0)))
         *PropInfo->name="Event"+chr(0)
         return PropInfo
    case else
        return Base.GetPropInfo(n)
    end select
end function

function QButton.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "onclick"
         dim as zstring ptr result=callocate(len(str(onclick))+1)
         *result=str(onclick)+chr(0)
         return result
    case else
        return Base.GetPropValue(n)
    end select
end function

function QButton.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as zstring ptr old
    select case lcase(n)
    case "onclick"
         old=callocate(len(str(onclick)+chr(0)))
         *old=str(onclick)
         dim as integer i=val(*v)
         onClick=cast(QEvent,i)
         return old<>onclick
    case else
        return Base.SetPropValue(n,v)
    end select
end function

function QButton.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function

/'QImage'/
function QImage.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QImage.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QImage.GetPropInfo(n as string) as PELPropInfo
     PropInfo=new QELPropInfo
    PropInfo->typename=callocate(len(n+chr(0)))
    *PropInfo->typename=n
    select case lcase(n)
    case "onclick"
         PropInfo->value=callocate(len(str(onclick))+1)
         *PropInfo->value=str(onclick)+chr(0)
         PropInfo->name=callocate(len("Event"+chr(0)))
         *PropInfo->name="Event"+chr(0)
         return PropInfo
    case else
        return Base.GetPropInfo(n)
    end select
end function

function QImage.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "onclick"
         dim as zstring ptr result=callocate(len(str(onclick))+1)
         *result=str(onclick)+chr(0)
         return result
    case else
        return Base.GetPropValue(n)
    end select
end function

function QImage.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as zstring ptr old
    select case lcase(n)
    case "onclick"
         old=callocate(len(str(onclick))+1)
         *old=str(onclick)+chr(0)
         dim as integer i=val(*v)
         onClick=cast(QEvent,i)
         return old<>onclick
    case else
        return Base.SetPropValue(n,v)
    end select
end function

function QImage.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function


/'QCheckBox'/
function QCheckBox.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QCheckBox.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QCheckBox.GetPropInfo(n as string) as PELPropInfo
     PropInfo=new QELPropInfo
    PropInfo->typename=callocate(len(n)+1)
    *PropInfo->typename=n+chr(0)
    select case lcase(n)
    case "onclick"
         PropInfo->value=callocate(len(str(onclick))+1)
         *PropInfo->value=str(onclick)+chr(0)
         PropInfo->name=callocate(len("Event")+1)
         *PropInfo->name="Event"+chr(0)
         return PropInfo
    case else
        return Base.GetPropInfo(n)
    end select
end function

function QCheckBox.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "onclick"
         dim as zstring ptr result=callocate(len(str(onclick))+1)
         *result=str(onclick)+chr(0)
         return result
    case else
        return Base.GetPropValue(n)
    end select
end function

function QCheckBox.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as zstring ptr old
    select case lcase(n)
    case "onclick"
         old=callocate(len(str(onclick))+1)
         *old=str(onclick)+chr(0)
         dim as integer i=val(*v)
         onClick=cast(QEvent,i)
         return old<>onclick
    case else
        return Base.SetPropValue(n,v)
    end select
end function

function QCheckBox.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function


/'QRadioButton'/
function QRadioButton.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QRadioButton.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QRadioButton.GetPropInfo(n as string) as PELPropInfo
     PropInfo=new QELPropInfo
    PropInfo->typename=callocate(len(n+chr(0)))
    *PropInfo->typename=n
    select case lcase(n)
    case "onclick"
         PropInfo->value=callocate(len(str(onclick))+1)
         *PropInfo->value=str(onclick)+chr(0)
         PropInfo->name=callocate(len("Event")+1)
         *PropInfo->name="Event"+chr(0)
         return PropInfo
    case else
        return Base.GetPropInfo(n)
    end select
end function

function QRadioButton.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "onclick"
         dim as zstring ptr result=callocate(len(str(onclick))+1)
         *result=str(onclick)+chr(0)
         return result
    case else
        return Base.GetPropValue(n)
    end select
end function

function QRadioButton.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as zstring ptr old
    select case lcase(n)
    case "onclick"
         old=callocate(len(str(onclick))+1)
         *old=str(onclick)+chr(0)
         dim as integer i=val(*v)
         onClick=cast(QEvent,i)
         return old<>onclick
    case else
        return Base.SetPropValue(n,v)
    end select
end function

function QRadioButton.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function


/'QGroupBox'/
function QGroupBox.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QGroupBox.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QGroupBox.GetPropInfo(n as string) as PELPropInfo
     PropInfo=new QELPropInfo
    PropInfo->typename=callocate(len(n)+1)
    *PropInfo->typename=n+chr(0)
    select case lcase(n)
    case "onclick"
         PropInfo->value=callocate(len(str(onclick))+1)
         *PropInfo->value=str(onclick)+chr(0)
         PropInfo->name=callocate(len("Event")+1)
         *PropInfo->name="Event"+chr(0)
         return PropInfo
    case else
        return Base.GetPropInfo(n)
    end select
end function

function QGroupBox.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "onclick"
         dim as zstring ptr result=callocate(len(str(onclick))+1)
         *result=str(onclick)+chr(0)
         return result
    case else
        return Base.GetPropValue(n)
    end select
end function

function QGroupBox.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as zstring ptr old
    select case lcase(n)
    case "onclick"
         old=callocate(len(str(onclick))+1)
         *old=str(onclick)+chr(0)
         dim as integer i=val(*v)
         onClick=cast(QEvent,i)
         return old<>onclick
    case else
        return Base.SetPropValue(n,v)
    end select
end function

function QGroupBox.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function

/'QEdit'/
function QEdit.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QEdit.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QEdit.GetPropInfo(n as string) as PELPropInfo
     PropInfo=new QELPropInfo
    PropInfo->typename=callocate(len(n)+1)
    *PropInfo->typename=n+chr(0)
    select case lcase(n)
    case "onclick"
         PropInfo->value=callocate(len(str(onclick))+1)
         *PropInfo->value=str(onclick)+chr(0)
         PropInfo->name=callocate(len("Event")+1)
         *PropInfo->name="Event"+chr(0)
         return PropInfo
    case else
        return Base.GetPropInfo(n)
    end select
end function

function QEdit.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "onclick"
         dim as zstring ptr result=callocate(len(str(onclick))+1)
         *result=str(onclick)+chr(0)
         return result
    case else
        return Base.GetPropValue(n)
    end select
end function

function QEdit.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as zstring ptr old
    select case lcase(n)
    case "onclick"
         old=callocate(len(str(onclick))+1)
         *old=str(onclick)+chr(0)
         dim as integer i=val(*v)
         onClick=cast(QEvent,i)
         return old<>onclick
    case else
        return Base.SetPropValue(n,v)
    end select
end function

function QEdit.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function

/'QComboBox'/
function QComboBox.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QComboBox.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QComboBox.GetPropInfo(n as string) as PELPropInfo
     PropInfo=new QELPropInfo
    PropInfo->typename=callocate(len(n)+1)
    *PropInfo->typename=n+chr(0)
    select case lcase(n)
    case "onclick"
         PropInfo->value=callocate(len(str(onclick))+1)
         *PropInfo->value=str(onclick)+chr(0)
         PropInfo->name=callocate(len("Event")+1)
         *PropInfo->name="Event"+chr(0)
         return PropInfo
    case else
        return Base.GetPropInfo(n)
    end select
end function

function QComboBox.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "onclick"
         dim as zstring ptr result=callocate(len(str(onclick))+1)
         *result=str(onclick)+chr(0)
         return result
    case else
        return Base.GetPropValue(n)
    end select
end function

function QComboBox.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as zstring ptr old
    select case lcase(n)
    case "onclick"
         old=callocate(len(str(onclick))+1)
         *old=str(onclick)+chr(0)
         dim as integer i=val(*v)
         onClick=cast(QEvent,i)
         return old<>onclick
    case else
        return Base.SetPropValue(n,v)
    end select
end function

function QComboBox.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function


/'QListBox'/
function QListBox.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QListBox.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QListBox.GetPropInfo(n as string) as PELPropInfo
     PropInfo=new QELPropInfo
    PropInfo->typename=callocate(len(n)+1)
    *PropInfo->typename=n+chr(0)
    select case lcase(n)
    case "onclick"
         PropInfo->value=callocate(len(str(onclick))+1)
         *PropInfo->value=str(onclick)+chr(0)
         PropInfo->name=callocate(len("Event")+1)
         *PropInfo->name="Event"+chr(0)
         return PropInfo
    case else
        return Base.GetPropInfo(n)
    end select
end function

function QListBox.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "onclick"
         dim as zstring ptr result=callocate(len(str(onclick))+1)
         *result=str(onclick)+chr(0)
         return result
    case else
        return Base.GetPropValue(n)
    end select
end function

function QListBox.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as zstring ptr old
    select case lcase(n)
    case "onclick"
         old=callocate(len(str(onclick))+1)
         *old=str(onclick)+chr(0)
         dim as integer i=val(*v)
         onClick=cast(QEvent,i)
         return old<>onclick
    case else
        return Base.SetPropValue(n,v)
    end select
end function

function QListBox.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function

/'QScrollBar'/
function QScrollBar.MethodExists(m as string) as any ptr
    return base.MethodExists(m)
end function

function QScrollBar.GetPropList as zstring ptr
    dim as string s=*Base.GetPropList+chr(0)
    dim as zstring ptr zs=callocate(len(s))
    *zs=s
    return zs
end function

function QScrollBar.GetPropInfo(n as string) as PELPropInfo
   PropInfo=new QELPropInfo
    PropInfo->typename=callocate(len(n)+1)
    *PropInfo->typename=n+chr(0)
    select case lcase(n)
    case "onclick"
         PropInfo->value=callocate(len(str(onclick))+1)
         *PropInfo->value=str(onclick)+chr(0)
         PropInfo->name=callocate(len("Event")+1)
         *PropInfo->name="Event"+chr(0)
         return PropInfo
    case else
        return Base.GetPropInfo(n)
    end select
end function

function QScrollBar.GetPropValue(n as string) as zstring ptr
    select case lcase(n)
    case "onclick"
         dim as zstring ptr result=callocate(len(str(onclick))+1)
         *result=str(onclick)+chr(0)
         return result
    case else
        return Base.GetPropValue(n)
    end select
end function

function QScrollBar.SetPropValue(n as string,v as zstring ptr) as boolean
    dim as zstring ptr old
    select case ucase(n)
    case "onclick"
         old=callocate(len(str(onclick))+1)
         *old=str(onclick)+chr(0)
         dim as integer i=val(*v)
         onClick=cast(QEvent,i)
         return old<>onclick
    case else
        return Base.SetPropValue(n,v)
    end select
end function

function QScrollBar.InheritsFrom(n as string) as boolean
    return Base.InheritsFrom(n)
end function

#endif